Package tigase.db

# Class AuthRepositoryMDImpl

java.lang.Object
tigase.db.beans.MDPoolBean<S,T>
tigase.db.beans.MDPoolBeanWithStatistics<AuthRepository,AuthRepositoryMDPoolBean.AuthRepositoryConfigBean>
tigase.db.AuthRepositoryMDImpl

All Implemented Interfaces:
  `AuthRepository`, `Repository`, `RegistrarBean`, `RegistrarBeanWithDefaultBeanClass`, `ComponentStatisticsProvider`, `StatisticsProviderIfc`

Direct Known Subclasses:
  `AuthRepositoryMDPoolBean`

public abstract class AuthRepositoryMDImpl extends MDPoolBeanWithStatistics<AuthRepository,AuthRepositoryMDPoolBean.AuthRepositoryConfigBean> implements AuthRepository
Implementation of multi domain pool for authentication repositories. Created: Mar 27, 2010 9:10:21 PM

Author:
  Artur Hefczyc

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface tigase.db.AuthRepository

  `AuthRepository.AccountStatus, AuthRepository.DefaultCredentials, AuthRepository.SingleCredential`

  ## Nested classes/interfaces inherited from interface tigase.db.Repository

  `Repository.Meta, Repository.SchemaId`

- ## Field Summary

  ### Fields inherited from class tigase.db.beans.MDPoolBean

  `POOL_CLASS, POOL_SIZE, REPO_CLASS, REPO_URI`

  ### Fields inherited from interface tigase.db.AuthRepository

  `DATA_KEY, DIGEST_ID_KEY, DIGEST_KEY, MACHANISM_KEY, PASSWORD_KEY, PROTOCOL_KEY, PROTOCOL_VAL_NONSASL, PROTOCOL_VAL_SASL, REALM_KEY, RESULT_KEY, SERVER_NAME_KEY, USER_ID_KEY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AuthRepositoryMDImpl()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addUser(BareJID user, String password)`
  `AuthRepository.AccountStatus`
  `getAccountStatus(BareJID user)`
  `long`
  `getActiveUsersCountIn(Duration duration)`
  `Collection<String>`
  `getCredentialIds(BareJID user)`
  `Credentials`
  `getCredentials(BareJID user, String credentialId)`
  `String`
  `getPassword(BareJID user)`
  `String`
  `getResourceUri()`
  `getResourceUri` method returns database connection string.
  `long`
  `getUsersCount()`
  This method is only used by the server statistics component to report number of registered users.
  `long`
  `getUsersCount(String domain)`
  This method is only used by the server statistics component to report number of registered users for given domain.
  `void`
  `initRepository(String resource_uri, Map<String,String> params)`
  Method is deprecated and should not be user any more.
  `boolean`
  `isMechanismSupported(String domain, String mechanism)`
  `boolean`
  `isUserDisabled(BareJID user)`
  `void`
  `loggedIn(BareJID user)`
  Do some actions on repository, when user logs in.
  `void`
  `logout(BareJID user)`
  `boolean`
  `otherAuth(Map<String,Object> authProps)`
  `void`
  `queryAuth(Map<String,Object> authProps)`
  `queryAuth` returns mechanisms available for authentication.
  `void`
  `removeCredential(BareJID user, String credentialId)`
  `void`
  `removeUser(BareJID user)`
  `void`
  `setAccountStatus(BareJID user, AuthRepository.AccountStatus status)`
  `void`
  `setUserDisabled(BareJID user, Boolean value)`
  `void`
  `updateCredential(BareJID user, String credentialId, String password)`
  `void`
  `updateCredential(BareJID user, String credentialId, String mechanism, String data)`
  `void`
  `updatePassword(BareJID user, String password)`

  ### Methods inherited from class tigase.db.beans.MDPoolBeanWithStatistics

  `addRepo, everyHour, everyMinute, everySecond, getDefaultRepository, getDomainsList, getRepo, getStatistics, removeRepo, repositoriesStream, setDefault, setStatisticsEnabled, wrapInProxy`

  ### Methods inherited from class tigase.db.beans.MDPoolBean

  `getConfigClass, getDefaultAlias, getName, register, registerConfigBean, unregister`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface tigase.db.AuthRepository

  `getUsernames, setCredentialsCodecs`

  ### Methods inherited from interface tigase.stats.ComponentStatisticsProvider

  `belongsTo`

  ### Methods inherited from interface tigase.kernel.beans.RegistrarBeanWithDefaultBeanClass

  `getDefaultBeanClass`

- ## Constructor Details

  - ### AuthRepositoryMDImpl

    public AuthRepositoryMDImpl()

- ## Method Details

  - ### addUser

    public void addUser(BareJID user, String password) throws TigaseDBException
    Specified by:
      `addUser` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getAccountStatus

    public AuthRepository.AccountStatus getAccountStatus(BareJID user) throws TigaseDBException
    Specified by:
      `getAccountStatus` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getCredentials

    public Credentials getCredentials(BareJID user, String credentialId) throws TigaseDBException
    Specified by:
      `getCredentials` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getPassword

    public String getPassword(BareJID user) throws TigaseDBException
    Specified by:
      `getPassword` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getResourceUri

    public String getResourceUri()
    Description copied from interface: `AuthRepository`
    `getResourceUri` method returns database connection string.
    Specified by:
      `getResourceUri` in interface `AuthRepository`
    Returns:
      a `String` value of database connection string.

  - ### getCredentialIds

    public Collection<String> getCredentialIds(BareJID user) throws TigaseDBException
    Specified by:
      `getCredentialIds` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getActiveUsersCountIn

    public long getActiveUsersCountIn(Duration duration)
    Specified by:
      `getActiveUsersCountIn` in interface `AuthRepository`
    Parameters:
      `duration` - Time range within which active users should be counted. Method is only used by statistics.
    Returns:
      number of active users in required range

  - ### getUsersCount

    public long getUsersCount()
    Description copied from interface: `AuthRepository`
    This method is only used by the server statistics component to report number of registered users.
    Specified by:
      `getUsersCount` in interface `AuthRepository`
    Returns:
      a `long` number of registered users in the repository.

  - ### getUsersCount

    public long getUsersCount(String domain)
    Description copied from interface: `AuthRepository`
    This method is only used by the server statistics component to report number of registered users for given domain.
    Specified by:
      `getUsersCount` in interface `AuthRepository`
    Parameters:
      `domain` - for which get the statistics
    Returns:
      a `long` number of registered users in the repository.

  - ### initRepository

    public void initRepository(String resource_uri, Map<String,String> params) throws DBInitException
    Description copied from interface: `Repository`
    Method is deprecated and should not be user any more.
    The method is called to initialize the data repository. Depending on the implementation all the initialization parameters can be passed either via `resource_uri` parameter as the database connection string or via `params` map if the required repository parameters are more complex or both.
    Specified by:
      `initRepository` in interface `Repository`
    Parameters:
      `resource_uri` - value in most cases representing the database connection string.
      `params` - is a `Map` with repository properties necessary to initialize and perform all the functions. The initialization parameters are implementation dependent.
    Throws:
      `DBInitException` - if there was an error during repository initialization. Some implementations, though, perform so called lazy initialization so even though there is a problem with the underlying repository it may not be signaled through this method call.

  - ### isMechanismSupported

    public boolean isMechanismSupported(String domain, String mechanism)
    Specified by:
      `isMechanismSupported` in interface `AuthRepository`

  - ### isUserDisabled

    public boolean isUserDisabled(BareJID user) throws TigaseDBException
    Specified by:
      `isUserDisabled` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### loggedIn

    public void loggedIn(BareJID user) throws TigaseDBException
    Description copied from interface: `AuthRepository`
    Do some actions on repository, when user logs in. (for example update `last_login_time`)
    Specified by:
      `loggedIn` in interface `AuthRepository`
    Parameters:
      `user` - JID of logged user.
    Throws:
      `TigaseDBException` - if an error occurs

  - ### logout

    public void logout(BareJID user) throws TigaseDBException
    Specified by:
      `logout` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### otherAuth

    public boolean otherAuth(Map<String,Object> authProps) throws TigaseDBException, AuthorizationException
    Specified by:
      `otherAuth` in interface `AuthRepository`
    Throws:
      `TigaseDBException`
      `AuthorizationException`

  - ### queryAuth

    public void queryAuth(Map<String,Object> authProps)
    Description copied from interface: `AuthRepository`
    `queryAuth` returns mechanisms available for authentication.
    Specified by:
      `queryAuth` in interface `AuthRepository`
    Parameters:
      `authProps` - a `Map` value with parameters for authentication.

  - ### removeCredential

    public void removeCredential(BareJID user, String credentialId) throws TigaseDBException
    Specified by:
      `removeCredential` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### removeUser

    public void removeUser(BareJID user) throws TigaseDBException
    Specified by:
      `removeUser` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### setAccountStatus

    public void setAccountStatus(BareJID user, AuthRepository.AccountStatus status) throws TigaseDBException
    Specified by:
      `setAccountStatus` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### setUserDisabled

    public void setUserDisabled(BareJID user, Boolean value) throws TigaseDBException
    Specified by:
      `setUserDisabled` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### updateCredential

    public void updateCredential(BareJID user, String credentialId, String password) throws TigaseDBException
    Specified by:
      `updateCredential` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### updateCredential

    public void updateCredential(BareJID user, String credentialId, String mechanism, String data) throws TigaseDBException
    Specified by:
      `updateCredential` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### updatePassword

    public void updatePassword(BareJID user, String password) throws TigaseDBException
    Specified by:
      `updatePassword` in interface `AuthRepository`
    Throws:
      `TigaseDBException`